package com.usai.redant.photo;

import com.usai.util.dbUtil;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.annotation.TargetApi;
import android.app.Activity;
import android.content.ContentValues;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.TextView;

/**
 * Activity which displays a login screen to the user, offering registration as
 * well.
 */
public class LockerActivity extends Activity {
	/**
	 * A dummy authentication store containing known user names and passwords.
	 * TODO: remove after connecting to a real authentication system.
	 */
//	private static final String[] DUMMY_CREDENTIALS = new String[] {
//			"foo@example.com:hello", "bar@example.com:world" };

	/**
	 * The default email to populate the email field with.
	 */
	public static final String EXTRA_EMAIL = "com.example.android.authenticatordemo.extra.EMAIL";

	/**
	 * Keep track of the login task to ensure we can cancel it if requested.
	 */
	private UserLoginTask mAuthTask = null;

	SQLiteDatabase m_db;
	// Values for email and password at the time of the login attempt.
	private String m_sName;
	private String m_sPassword;

	// UI references.
	private EditText m_etName;
	private EditText m_etPassword;
	private View mLoginFormView;
	private View mLoginStatusView;
	private TextView mLoginStatusMessageView;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_locker);

		// Set up the login form.
//		m_sName = getIntent().getStringExtra(EXTRA_USER);
		m_etName = (EditText) findViewById(R.id.name);
		
//		m_etName.setText(m_sName);

		m_etPassword = (EditText) findViewById(R.id.password);
		m_etPassword
				.setOnEditorActionListener(new TextView.OnEditorActionListener() {
					@Override
					public boolean onEditorAction(TextView textView, int id,
							KeyEvent keyEvent) {
Log.d("onEditorAction", "id="+id+" keyevent="+keyEvent);
						if (id == R.id.locker || id == EditorInfo.IME_ACTION_DONE ) {
							attemptLogin();
							return true;
						}
						return false;
					}
				});

		mLoginFormView = findViewById(R.id.login_form);
		mLoginStatusView = findViewById(R.id.login_status);
		mLoginStatusMessageView = (TextView) findViewById(R.id.login_status_message);

		findViewById(R.id.sign_in_button).setOnClickListener(
				new View.OnClickListener() {
					@Override
					public void onClick(View view) {
						attemptLogin();
					}
				});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		getMenuInflater().inflate(R.menu.locker, menu);
		return true;
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
        if(keyCode == KeyEvent.KEYCODE_BACK){
//            Intent myIntent = new Intent();
//            myIntent = new Intent(EditActivity.this, tabActivity.class);
//            startActivity(myIntent);
//            this.finish();
        	return true;
        }
        return super.onKeyDown(keyCode, event);

	}

	/**
	 * Attempts to sign in or register the account specified by the login form.
	 * If there are form errors (invalid email, missing fields, etc.), the
	 * errors are presented and no actual login attempt is made.
	 */
	public void attemptLogin() {
		if (mAuthTask != null) {
			return;
		}

		// Reset errors.
		m_etName.setError(null);
		m_etPassword.setError(null);

		// Store values at the time of the login attempt.
		m_sName = m_etName.getText().toString();
		m_sPassword = m_etPassword.getText().toString();

		boolean cancel = false;
		View focusView = null;

		// Check for a valid password.
		if (TextUtils.isEmpty(m_sPassword)) {
			m_etPassword.setError(getString(R.string.error_field_required));
			focusView = m_etPassword;
			cancel = true;
		} else if (m_sPassword.length() < 4) {
			m_etPassword.setError(getString(R.string.error_invalid_password));
			focusView = m_etPassword;
			cancel = true;
		}

		// Check for a valid user name.
		if (TextUtils.isEmpty(m_sName)) {
			m_etName.setError(getString(R.string.error_field_required));
			focusView = m_etName;
			cancel = true;
		}
		// else if (!m_sName.contains("@")) {
		// m_etName.setError(getString(R.string.error_invalid_email));
		// focusView = m_etName;
		// cancel = true;
		// }

		if (cancel) {
			// There was an error; don't attempt login and focus the first
			// form field with an error.
			focusView.requestFocus();
		} else {
			// Show a progress spinner, and kick off a background task to
			// perform the user login attempt.
			mLoginStatusMessageView.setText(R.string.login_progress_signing_in);
			showProgress(true);
			mAuthTask = new UserLoginTask();
			mAuthTask.execute((Void) null);
		}
	}

	/**
	 * Shows the progress UI and hides the login form.
	 */
	@TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
	private void showProgress(final boolean show) {
		// On Honeycomb MR2 we have the ViewPropertyAnimator APIs, which allow
		// for very easy animations. If available, use these APIs to fade-in
		// the progress spinner.
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB_MR2) {
			int shortAnimTime = getResources().getInteger(
					android.R.integer.config_shortAnimTime);

			mLoginStatusView.setVisibility(View.VISIBLE);
			mLoginStatusView.animate().setDuration(shortAnimTime)
					.alpha(show ? 1 : 0)
					.setListener(new AnimatorListenerAdapter() {
						@Override
						public void onAnimationEnd(Animator animation) {
							mLoginStatusView.setVisibility(show ? View.VISIBLE
									: View.GONE);
						}
					});

			mLoginFormView.setVisibility(View.VISIBLE);
			mLoginFormView.animate().setDuration(shortAnimTime)
					.alpha(show ? 0 : 1)
					.setListener(new AnimatorListenerAdapter() {
						@Override
						public void onAnimationEnd(Animator animation) {
							mLoginFormView.setVisibility(show ? View.GONE
									: View.VISIBLE);
						}
					});
		} else {
			// The ViewPropertyAnimator APIs are not available, so simply show
			// and hide the relevant UI components.
			mLoginStatusView.setVisibility(show ? View.VISIBLE : View.GONE);
			mLoginFormView.setVisibility(show ? View.GONE : View.VISIBLE);
		}
	}

	/**
	 * Represents an asynchronous login/registration task used to authenticate
	 * the user.
	 */
	public class UserLoginTask extends AsyncTask<Void, Void, Boolean> {
		@Override
		protected Boolean doInBackground(Void... params) {

			m_db = dbUtil.OpenDB(LockerActivity.this, null, true);

			Cursor cursor = m_db.query("users", new String[] {  "pass",
					"_id" }, "name= '"+m_sName+"'", null, null, null, "_id desc", null);
			if (cursor.moveToNext()) {
				// user exist in local db;
//				Log.d(TAG, "USER "+m_sName+" exist!");
				String pass = cursor.getString(0);
				if (pass.equals(m_sPassword))
					return true;
				else {
					return false;// wrong password
				}
			} else {
				// user not exist in local db;
				try {
					// Simulate network access.
					Thread.sleep(2000);
				} catch (InterruptedException e) {
					return false;
				}
				// TODO: register the new account here.
				// online check user here;
				if (true)// check pass create user in local db;
				{
					ContentValues cv = new ContentValues();
					cv.put("name", m_sName);
					cv.put("pass", m_sPassword);


					m_db.insert("users", null, cv);

					return true;

				} else {
					// no user exist on the server;
					return false;
				}
			}
		}
		
		@Override
		protected void onPostExecute(final Boolean success) {
			mAuthTask = null;
			showProgress(false);

			if (success) {
				
//				SharedPreferences.Editor editor = RunOnce.edit();
//				editor.putBoolean("FirstRun"+globalUtil.getVerName(this), false);
//				// Don't forget to commit your edits!!!
//				editor.commit();
                
                Intent intent = new Intent();
                intent.putExtra("user", m_sName);
                /*
                 * 调用setResult方法表示我将Intent对象返回给之前的那个Activity，这样就可以在onActivityResult方法中得到Intent对象，
                 */
                setResult(Activity.RESULT_OK, intent);			
				finish();
			} else {
				m_etPassword
						.setError(getString(R.string.error_incorrect_password));
				m_etPassword.requestFocus();
			}
		}
		@Override
		protected void onCancelled() {
			mAuthTask = null;
			showProgress(false);
		}
	}
}
